Index: uspace/lib/ui/src/tabset.c
===================================================================
--- uspace/lib/ui/src/tabset.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/src/tabset.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,278 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab set
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <gfx/render.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <ui/control.h>
+#include <ui/tab.h>
+#include <ui/tabset.h>
+#include <ui/window.h>
+#include "../private/tab.h"
+#include "../private/tabset.h"
+#include "../private/resource.h"
+
+static void ui_tab_set_ctl_destroy(void *);
+static errno_t ui_tab_set_ctl_paint(void *);
+static ui_evclaim_t ui_tab_set_ctl_kbd_event(void *, kbd_event_t *);
+static ui_evclaim_t ui_tab_set_ctl_pos_event(void *, pos_event_t *);
+
+/** Tab set control ops */
+ui_control_ops_t ui_tab_set_ops = {
+	.destroy = ui_tab_set_ctl_destroy,
+	.paint = ui_tab_set_ctl_paint,
+	.kbd_event = ui_tab_set_ctl_kbd_event,
+	.pos_event = ui_tab_set_ctl_pos_event
+};
+
+/** Create new tab set.
+ *
+ * @param res UI resource
+ * @param rtabset Place to store pointer to new tab set
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_tab_set_create(ui_resource_t *res, ui_tab_set_t **rtabset)
+{
+	ui_tab_set_t *tabset;
+	errno_t rc;
+
+	tabset = calloc(1, sizeof(ui_tab_set_t));
+	if (tabset == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&ui_tab_set_ops, (void *) tabset, &tabset->control);
+	if (rc != EOK) {
+		free(tabset);
+		return rc;
+	}
+
+	tabset->res = res;
+	list_initialize(&tabset->tabs);
+	*rtabset = tabset;
+	return EOK;
+}
+
+/** Destroy tab set
+ *
+ * @param tabset Tab set or @c NULL
+ */
+void ui_tab_set_destroy(ui_tab_set_t *tabset)
+{
+	ui_tab_t *tab;
+
+	if (tabset == NULL)
+		return;
+
+	/* Destroy tabs */
+	tab = ui_tab_first(tabset);
+	while (tab != NULL) {
+		ui_tab_destroy(tab);
+		tab = ui_tab_first(tabset);
+	}
+
+	ui_control_delete(tabset->control);
+	free(tabset);
+}
+
+/** Get base control from tab set.
+ *
+ * @param tabset Tab set
+ * @return Control
+ */
+ui_control_t *ui_tab_set_ctl(ui_tab_set_t *tabset)
+{
+	return tabset->control;
+}
+
+/** Set tab set rectangle.
+ *
+ * @param tabset Tab set
+ * @param rect New tab set rectangle
+ */
+void ui_tab_set_set_rect(ui_tab_set_t *tabset, gfx_rect_t *rect)
+{
+	tabset->rect = *rect;
+}
+
+/** Paint tab set.
+ *
+ * @param tabset Tab set
+ * @return EOK on success or an error code
+ */
+errno_t ui_tab_set_paint(ui_tab_set_t *tabset)
+{
+	ui_resource_t *res;
+	ui_tab_t *tab;
+	errno_t rc;
+
+	res = tabset->res;
+
+	if (tabset->selected != NULL) {
+		rc = ui_tab_paint_body_frame(tabset->selected);
+		if (rc != EOK)
+			goto error;
+	}
+
+	tab = ui_tab_first(tabset);
+	while (tab != NULL) {
+		rc = ui_tab_paint(tab);
+		if (rc != EOK)
+			return rc;
+
+		tab = ui_tab_next(tab);
+	}
+
+	rc = gfx_update(res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Select or deselect tab from tab set.
+ *
+ * Select @a tab. If @a tab is @c NULL or it is already selected,
+ * then select none.
+ *
+ * @param tabset Tab set
+ * @param tab Tab to select (or deselect if selected) or @c NULL
+ */
+void ui_tab_set_select(ui_tab_set_t *tabset, ui_tab_t *tab)
+{
+	tabset->selected = tab;
+	(void) ui_tab_set_paint(tabset);
+}
+
+/** Handle tab set keyboard event.
+ *
+ * @param tabset Tab set
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_tab_set_kbd_event(ui_tab_set_t *tabset, kbd_event_t *event)
+{
+	ui_tab_t *tab;
+	ui_evclaim_t claim;
+
+	tab = ui_tab_first(tabset);
+	while (tab != NULL) {
+		claim = ui_tab_kbd_event(tab, event);
+		if (claim == ui_claimed)
+			return ui_claimed;
+
+		tab = ui_tab_next(tab);
+	}
+
+	return ui_unclaimed;
+}
+
+/** Handle tab set position event.
+ *
+ * @param tabset Tab set
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_tab_set_pos_event(ui_tab_set_t *tabset, pos_event_t *event)
+{
+	ui_tab_t *tab;
+	ui_evclaim_t claim;
+
+	tab = ui_tab_first(tabset);
+	while (tab != NULL) {
+		claim = ui_tab_pos_event(tab, event);
+		if (claim == ui_claimed)
+			return ui_claimed;
+
+		tab = ui_tab_next(tab);
+	}
+
+	return ui_unclaimed;
+}
+
+/** Destroy tab set control.
+ *
+ * @param arg Argument (ui_tab_set_t *)
+ */
+static void ui_tab_set_ctl_destroy(void *arg)
+{
+	ui_tab_set_t *tabset = (ui_tab_set_t *) arg;
+
+	ui_tab_set_destroy(tabset);
+}
+
+/** Paint tab set control.
+ *
+ * @param arg Argument (ui_tab_set_t *)
+ * @return EOK on success or an error code
+ */
+static errno_t ui_tab_set_ctl_paint(void *arg)
+{
+	ui_tab_set_t *tabset = (ui_tab_set_t *) arg;
+
+	return ui_tab_set_paint(tabset);
+}
+
+/** Handle tab set control keyboard event.
+ *
+ * @param arg Argument (ui_tab_set_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+static ui_evclaim_t ui_tab_set_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	ui_tab_set_t *tabset = (ui_tab_set_t *) arg;
+
+	return ui_tab_set_kbd_event(tabset, event);
+}
+
+/** Handle tab set control position event.
+ *
+ * @param arg Argument (ui_tab_set_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+static ui_evclaim_t ui_tab_set_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	ui_tab_set_t *tabset = (ui_tab_set_t *) arg;
+
+	return ui_tab_set_pos_event(tabset, event);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/testctl.c
===================================================================
--- uspace/lib/ui/src/testctl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/src/testctl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,159 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Test control
+ *
+ * Test control allows to read the arguments of and inject the responses
+ * to all control methods.
+ */
+
+#include <errno.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/testctl.h>
+#include "../private/testctl.h"
+
+static void test_ctl_destroy(void *);
+static errno_t test_ctl_paint(void *);
+static ui_evclaim_t test_ctl_kbd_event(void *, kbd_event_t *);
+static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
+static void test_ctl_unfocus(void *, unsigned);
+
+ui_control_ops_t ui_test_ctl_ops = {
+	.destroy = test_ctl_destroy,
+	.paint = test_ctl_paint,
+	.kbd_event = test_ctl_kbd_event,
+	.pos_event = test_ctl_pos_event,
+	.unfocus = test_ctl_unfocus
+};
+
+static void test_ctl_destroy(void *arg)
+{
+	ui_test_ctl_t *testctl = (ui_test_ctl_t *)arg;
+	ui_tc_resp_t *resp = testctl->resp;
+
+	resp->destroy = true;
+	ui_test_ctl_destroy(testctl);
+}
+
+static errno_t test_ctl_paint(void *arg)
+{
+	ui_test_ctl_t *testctl = (ui_test_ctl_t *)arg;
+	ui_tc_resp_t *resp = testctl->resp;
+
+	resp->paint = true;
+	return resp->rc;
+}
+
+static ui_evclaim_t test_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	ui_test_ctl_t *testctl = (ui_test_ctl_t *)arg;
+	ui_tc_resp_t *resp = testctl->resp;
+
+	resp->kbd = true;
+	resp->kevent = *event;
+
+	return resp->claim;
+}
+
+static ui_evclaim_t test_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	ui_test_ctl_t *testctl = (ui_test_ctl_t *)arg;
+	ui_tc_resp_t *resp = testctl->resp;
+
+	resp->pos = true;
+	resp->pevent = *event;
+
+	return resp->claim;
+}
+
+static void test_ctl_unfocus(void *arg, unsigned nfocus)
+{
+	ui_test_ctl_t *testctl = (ui_test_ctl_t *)arg;
+	ui_tc_resp_t *resp = testctl->resp;
+
+	resp->unfocus = true;
+	resp->unfocus_nfocus = nfocus;
+}
+
+/** Create new test control.
+ *
+ * @param resp Response structure
+ * @param rtest Place to store pointer to new test control
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_test_ctl_create(ui_tc_resp_t *resp, ui_test_ctl_t **rtest)
+{
+	ui_test_ctl_t *test;
+	errno_t rc;
+
+	test = calloc(1, sizeof(ui_test_ctl_t));
+	if (test == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&ui_test_ctl_ops, (void *)test, &test->control);
+	if (rc != EOK) {
+		free(test);
+		return rc;
+	}
+
+	test->resp = resp;
+	*rtest = test;
+	return EOK;
+}
+
+/** Destroy test control.
+ *
+ * @param test Test control or @c NULL
+ */
+void ui_test_ctl_destroy(ui_test_ctl_t *test)
+{
+	if (test == NULL)
+		return;
+
+	ui_control_delete(test->control);
+	free(test);
+}
+
+/** Get base control from test control.
+ *
+ * @param test Test control
+ * @return Control
+ */
+ui_control_t *ui_test_ctl_ctl(ui_test_ctl_t *test)
+{
+	return test->control;
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/ui.c
===================================================================
--- uspace/lib/ui/src/ui.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/ui.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,5 +39,7 @@
 #include <errno.h>
 #include <fibril.h>
+#include <fibril_synch.h>
 #include <gfx/color.h>
+#include <gfx/cursor.h>
 #include <gfx/render.h>
 #include <io/console.h>
@@ -46,7 +48,10 @@
 #include <str.h>
 #include <task.h>
+#include <types/common.h>
+#include <ui/clickmatic.h>
 #include <ui/ui.h>
 #include <ui/wdecor.h>
 #include <ui/window.h>
+#include "../private/wdecor.h"
 #include "../private/window.h"
 #include "../private/ui.h"
@@ -61,15 +66,18 @@
  * @param ws Place to store window system type (protocol)
  * @param osvc Place to store pointer to output service name
- */
-static void ui_ospec_parse(const char *ospec, ui_winsys_t *ws,
-    const char **osvc)
+ * @param ridev_id Place to store input device ID
+ * @return EOK on success, EINVAL if syntax is invalid, ENOMEM if out of
+ *         memory
+ */
+static errno_t ui_ospec_parse(const char *ospec, ui_winsys_t *ws,
+    char **osvc, sysarg_t *ridev_id)
 {
 	const char *cp;
-
-	if (ospec == UI_DISPLAY_DEFAULT) {
-		*ws = ui_ws_display;
-		*osvc = DISPLAY_DEFAULT;
-		return;
-	}
+	const char *qm;
+	const char *endptr;
+	uint64_t idev_id;
+	errno_t rc;
+
+	*ridev_id = 0;
 
 	cp = ospec;
@@ -77,4 +85,5 @@
 		++cp;
 
+	/* Window system / protocol */
 	if (*cp == '@') {
 		if (str_lcmp(ospec, "disp@", str_length("disp@")) == 0) {
@@ -84,16 +93,54 @@
 		} else if (str_lcmp(ospec, "null@", str_length("null@")) == 0) {
 			*ws = ui_ws_null;
+		} else if (str_lcmp(ospec, "@", str_length("@")) == 0) {
+			*ws = ui_ws_any;
 		} else {
 			*ws = ui_ws_unknown;
 		}
 
-		if (cp[1] != '\0')
-			*osvc = cp + 1;
-		else
-			*osvc = NULL;
+		++cp;
 	} else {
 		*ws = ui_ws_display;
-		*osvc = ospec;
-	}
+	}
+
+	/* Output service is the part before question mark */
+	qm = str_chr(cp, '?');
+	if (qm != NULL) {
+		*osvc = str_ndup(cp, qm - cp);
+	} else {
+		/* No question mark */
+		*osvc = str_dup(cp);
+	}
+
+	if (*osvc == NULL)
+		return ENOMEM;
+
+	if (qm != NULL) {
+		/* The part after the question mark */
+		cp = qm + 1;
+
+		/* Input device ID parameter */
+		if (str_lcmp(cp, "idev=", str_length("idev=")) == 0) {
+			cp += str_length("idev=");
+
+			rc = str_uint64_t(cp, &endptr, 10, false, &idev_id);
+			if (rc != EOK)
+				goto error;
+
+			*ridev_id = idev_id;
+			cp = endptr;
+		}
+	}
+
+	if (*cp != '\0') {
+		rc = EINVAL;
+		goto error;
+	}
+
+	return EOK;
+error:
+	free(*osvc);
+	*osvc = NULL;
+	return rc;
 }
 
@@ -114,30 +161,43 @@
 	console_gc_t *cgc;
 	ui_winsys_t ws;
-	const char *osvc;
+	char *osvc;
 	sysarg_t cols;
 	sysarg_t rows;
+	sysarg_t idev_id;
 	ui_t *ui;
 
-	ui_ospec_parse(ospec, &ws, &osvc);
-
-	if (ws == ui_ws_display) {
-		rc = display_open(osvc, &display);
+	rc = ui_ospec_parse(ospec, &ws, &osvc, &idev_id);
+	if (rc != EOK)
+		return rc;
+
+	if (ws == ui_ws_display || ws == ui_ws_any) {
+		rc = display_open((str_cmp(osvc, "") != 0) ? osvc :
+		    DISPLAY_DEFAULT, &display);
 		if (rc != EOK)
-			return rc;
+			goto disp_fail;
 
 		rc = ui_create_disp(display, &ui);
 		if (rc != EOK) {
 			display_close(display);
-			return rc;
-		}
-	} else if (ws == ui_ws_console) {
+			goto disp_fail;
+		}
+
+		free(osvc);
+		ui->myoutput = true;
+		ui->idev_id = idev_id;
+		*rui = ui;
+		return EOK;
+	}
+
+disp_fail:
+	if (ws == ui_ws_console || ws == ui_ws_any) {
 		console = console_init(stdin, stdout);
 		if (console == NULL)
-			return EIO;
+			goto cons_fail;
 
 		rc = console_get_size(console, &cols, &rows);
 		if (rc != EOK) {
 			console_done(console);
-			return rc;
+			goto cons_fail;
 		}
 
@@ -148,5 +208,5 @@
 		if (rc != EOK) {
 			console_done(console);
-			return rc;
+			goto cons_fail;
 		}
 
@@ -155,6 +215,8 @@
 			ui_destroy(ui);
 			console_done(console);
-			return rc;
-		}
+			goto cons_fail;
+		}
+
+		free(osvc);
 
 		ui->cgc = cgc;
@@ -165,15 +227,23 @@
 
 		(void) ui_paint(ui);
-	} else if (ws == ui_ws_null) {
+		ui->myoutput = true;
+		*rui = ui;
+		return EOK;
+	}
+
+cons_fail:
+	if (ws == ui_ws_null) {
+		free(osvc);
 		rc = ui_create_disp(NULL, &ui);
 		if (rc != EOK)
 			return rc;
-	} else {
-		return EINVAL;
-	}
-
-	ui->myoutput = true;
-	*rui = ui;
-	return EOK;
+
+		ui->myoutput = true;
+		*rui = ui;
+		return EOK;
+	}
+
+	free(osvc);
+	return EINVAL;
 }
 
@@ -186,4 +256,5 @@
 {
 	ui_t *ui;
+	errno_t rc;
 
 	ui = calloc(1, sizeof(ui_t));
@@ -191,6 +262,13 @@
 		return ENOMEM;
 
+	rc = ui_clickmatic_create(ui, &ui->clickmatic);
+	if (rc != EOK) {
+		free(ui);
+		return rc;
+	}
+
 	ui->console = console;
 	list_initialize(&ui->windows);
+	fibril_mutex_initialize(&ui->lock);
 	*rui = ui;
 	return EOK;
@@ -206,4 +284,5 @@
 {
 	ui_t *ui;
+	errno_t rc;
 
 	ui = calloc(1, sizeof(ui_t));
@@ -211,6 +290,13 @@
 		return ENOMEM;
 
+	rc = ui_clickmatic_create(ui, &ui->clickmatic);
+	if (rc != EOK) {
+		free(ui);
+		return rc;
+	}
+
 	ui->display = disp;
 	list_initialize(&ui->windows);
+	fibril_mutex_initialize(&ui->lock);
 	*rui = ui;
 	return EOK;
@@ -252,5 +338,7 @@
 	switch (event->type) {
 	case CEV_KEY:
+		ui_lock(ui);
 		ui_window_send_kbd(awnd, &event->ev.key);
+		ui_unlock(ui);
 		break;
 	case CEV_POS:
@@ -262,6 +350,9 @@
 		claim = ui_wdecor_pos_event(awnd->wdecor, &pos);
 		/* Note: If event is claimed, awnd might not be valid anymore */
-		if (claim == ui_unclaimed)
+		if (claim == ui_unclaimed) {
+			ui_lock(ui);
 			ui_window_send_pos(awnd, &pos);
+			ui_unlock(ui);
+		}
 
 		break;
@@ -355,4 +446,137 @@
 }
 
+/** Free up console for other users.
+ *
+ * Release console resources for another application (that the current
+ * task is starting). After the other application finishes, resume
+ * operation with ui_resume(). No calls to UI must happen inbetween
+ * and no events must be processed (i.e. the calling function must not
+ * return control to UI.
+ *
+ * @param ui UI
+ * @return EOK on success or an error code
+ */
+errno_t ui_suspend(ui_t *ui)
+{
+	errno_t rc;
+
+	assert(!ui->suspended);
+
+	if (ui->cgc == NULL) {
+		ui->suspended = true;
+		return EOK;
+	}
+
+	(void) console_set_caption(ui->console, "");
+	rc = console_gc_suspend(ui->cgc);
+	if (rc != EOK)
+		return rc;
+
+	ui->suspended = true;
+	return EOK;
+}
+
+/** Resume suspended UI.
+ *
+ * Reclaim console resources (after child application has finished running)
+ * and restore UI operation previously suspended by calling ui_suspend().
+ *
+ * @param ui UI
+ * @return EOK on success or an error code
+ */
+errno_t ui_resume(ui_t *ui)
+{
+	errno_t rc;
+	ui_window_t *awnd;
+	sysarg_t col;
+	sysarg_t row;
+	cons_event_t ev;
+
+	assert(ui->suspended);
+
+	if (ui->cgc == NULL) {
+		ui->suspended = false;
+		return EOK;
+	}
+
+	rc = console_get_pos(ui->console, &col, &row);
+	if (rc != EOK)
+		return rc;
+
+	/*
+	 * Here's a little heuristic to help determine if we need
+	 * to pause before returning to the UI. If we are in the
+	 * top-left corner, chances are the screen is empty and
+	 * there is no need to pause.
+	 */
+	if (col != 0 || row != 0) {
+		printf("Press any key or button to continue...\n");
+
+		while (true) {
+			rc = console_get_event(ui->console, &ev);
+			if (rc != EOK)
+				return EIO;
+
+			if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS)
+				break;
+
+			if (ev.type == CEV_POS && ev.ev.pos.type == POS_PRESS)
+				break;
+		}
+	}
+
+	rc = console_gc_resume(ui->cgc);
+	if (rc != EOK)
+		return rc;
+
+	ui->suspended = false;
+
+	awnd = ui_window_get_active(ui);
+	if (awnd != NULL)
+		(void) console_set_caption(ui->console, awnd->wdecor->caption);
+
+	rc = gfx_cursor_set_visible(console_gc_get_ctx(ui->cgc), false);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Determine if UI is suspended.
+ *
+ * @param ui UI
+ * @return @c true iff UI is suspended
+ */
+bool ui_is_suspended(ui_t *ui)
+{
+	return ui->suspended;
+}
+
+/** Lock UI.
+ *
+ * Block UI from calling window callbacks. @c ui_lock() and @c ui_unlock()
+ * must be used when accessing UI resources from a fibril (as opposed to
+ * from a window callback).
+ *
+ * @param ui UI
+ */
+void ui_lock(ui_t *ui)
+{
+	fibril_mutex_lock(&ui->lock);
+}
+
+/** Unlock UI.
+ *
+ * Allow UI to call window callbacks. @c ui_lock() and @c ui_unlock()
+ * must be used when accessing window resources from a fibril (as opposed to
+ * from a window callback).
+ *
+ * @param ui UI
+ */
+void ui_unlock(ui_t *ui)
+{
+	fibril_mutex_unlock(&ui->lock);
+}
+
 /** Terminate user interface.
  *
@@ -392,4 +616,47 @@
 }
 
+/** Get UI screen rectangle.
+ *
+ * @param ui User interface
+ * @param rect Place to store bounding rectangle
+ */
+errno_t ui_get_rect(ui_t *ui, gfx_rect_t *rect)
+{
+	display_info_t info;
+	sysarg_t cols, rows;
+	errno_t rc;
+
+	if (ui->display != NULL) {
+		rc = display_get_info(ui->display, &info);
+		if (rc != EOK)
+			return rc;
+
+		*rect = info.rect;
+	} else if (ui->console != NULL) {
+		rc = console_get_size(ui->console, &cols, &rows);
+		if (rc != EOK)
+			return rc;
+
+		rect->p0.x = 0;
+		rect->p0.y = 0;
+		rect->p1.x = cols;
+		rect->p1.y = rows;
+	} else {
+		return ENOTSUP;
+	}
+
+	return EOK;
+}
+
+/** Get clickmatic from UI.
+ *
+ * @pararm ui UI
+ * @return Clickmatic
+ */
+ui_clickmatic_t *ui_get_clickmatic(ui_t *ui)
+{
+	return ui->clickmatic;
+}
+
 /** @}
  */
